{   971115N2.PAS                                                             }
{   1997-11-15 lahtise olmpiaadi noorema rhma 2. lesande lahendus         }
{   Autor: Ahto Truu                                                         }

const
   max_t = 100;                             { suurim lubatud termiitide arv }
   max_m = 250;                           { suurim lubatud maatriksi suurus }
      { koordinaatide muutused vastvalt suunale: N = 0, O = 1, S = 2, W = 3 }
   dx : array [0..3] of integer = (0, 1, 0, -1);
   dy : array [0..3] of integer = (-1, 0, 1, 0);
type
   termiit = record
      x, y : integer;                                    { termiidi asukoht }
      s : byte;                { termiidi suund: N = 0, O = 1, S = 2, W = 3 }
   end;
var
   t : integer;                                            { termiitide arv }
   term : array [1..max_t] of termiit;                      { termiidid ise }
   m : integer;                                          { maatriksi suurus }
   matr : array [1..max_m, 1..max_m] of byte;                { maatriks ise }
   k : longint;                                               { kikude arv }
   f : text;
   i, j : integer;
   l : longint;
   c : char;
begin
      { loeme andmed failist }
   assign (f, 'input.txt'); reset (f);
   readln (f, t, m, k);
   for i := 1 to t do begin
      readln (f, term[i].x, term[i].y, c, c);
      term[i].s := pos (c, 'NOSW') - 1;
   end;
   close (f);
      { maatriksi algseis }
   for i := 1 to m do
      for j := 1 to m do
         matr[i, j] := 0;
      { teeme nutud arvu kike }
   for l := 1 to k do
      for i := 1 to t do
         with term[i] do begin
            x := x + dx[s];
            if x < 1 then x := m;
            if x > m then x := 1;
            y := y + dy[s];
            if y < 1 then y := m;
            if y > m then y := 1;
            matr[x, y] := 1 - matr[x, y];
            if matr[x, y] = 1 then
               s := (s + 3) mod 4
            else
               s := (s + 1) mod 4;
         end;
      { loeme 1 kokku }
   l := 0;
   for i := 1 to m do
      for j := 1 to m do
         l := l + matr[i, j];
      { kirjutame vastuse faili }
   assign (f, 'output.txt'); rewrite (f);
   writeln (f, l);
   close (f);
end.
