{  971115N3.PAS                                                             }
{  1997-11-15 lahtise olmpiaadi noorema rhma 3. lesande lahendus         }
{  Autor: Ahto Truu                                                         }

const
   max_tar = 10;                        { maksimaalne lubatud tariifide arv }
   max_ses = 10;                      { maksimaalne lubatud sessioonide arv }
type
   tariif = record                                         { tariifi andmed }
      alg : integer;    { tariifi kehtimahakkamise algus minutites sdast }
      lop : integer;     { tariifi kehtimahakkamise lpp minutites sdast }
      tar : integer;                                           { tariif ise }
   end;
var
   tarv : integer;                                          { tariifide arv }
   tar : array [1..2 * max_tar] of tariif; { tariifid ja varu poolitamiseks }
   sarv : integer;                                        { sessioonide arv }
   summa : real;                                            { makstav summa }

{ kellaaeg -> minuteid peva algusest }
function min (s : string) : integer;
var t, m, x : integer;
begin
   val (copy (s, 1, 2), t, x);
   val (copy (s, 4, 2), m, x);
   min := 60 * t + m;
end;

{ he sessiooni summa }
function sum (alg, lop : integer) : real;
var s : real; i, a, l : longint;
begin
   if alg > lop then
         { kui sessioon ulatub lesda, siis teeme pooleks }
      sum := sum (alg, 60 * 24) + sum (0, lop)
   else begin
         { muidu vrdleme kigi tariifidega }
      s := 0;
      for i := 1 to tarv do begin
         if alg < tar[i].alg then a := tar[i].alg else a := alg;
         if lop > tar[i].lop then l := tar[i].lop else l := lop;
         if a < l then s := s + (l - a) * tar[i].tar / 60;
      end;
      sum := s;
   end;
end;

var
   f : text;
   s : string;
   i, x : integer;
begin
      { loeme andmed failist }
   assign (f, 'input.txt'); reset (f);
   readln (f, tarv, sarv);
      { loeme tariifid }
   for i := 1 to tarv do begin
      readln (f, s);
      tar[i].alg := min (copy (s, 1, 5));
      tar[i].lop := min (copy (s, 9, 5));
      val (copy (s, 15, length (s) - 14), tar[i].tar, x);
   end;
      { normaliseerime tariifid }
   for i := 1 to tarv do begin
         { 24:00 ja 00:00 on sama kellaaja kaks esitust }
      if tar[i].alg = 60 * 24 then tar[i].alg := 0;
      if tar[i].lop = 0 then tar[i].lop := 60 * 24;
         { teeme kaheks tariifid, mis ulatavad le sda }
      if not (tar[i].alg < tar[i].lop) then begin
         tarv := tarv + 1;
         tar[tarv].alg := 0;
         tar[tarv].lop := tar[i].lop;
         tar[tarv].tar := tar[i].tar;
         tar[i].lop := 60 * 24;
      end;
   end;
      { loeme sessioonid, arvutades kigult ka summa }
   summa := 0;
   for i := 1 to sarv do begin
      readln (f, s);
      summa := summa + sum (min (copy (s, 1, 5)), min (copy (s, 9, 5)));
   end;
   close (f);
      { formaadime vastuse }
   str (round (20 * summa) / 20 :0:2, s);
   while s[length (s)] = '0' do s := copy (s, 1, length (s) - 1);
   if s[length (s)] = '.' then s := copy (s, 1, length (s) - 1);
      { kirjutame vastuse faili }
   assign (f, 'output.txt'); rewrite (f);
   writeln (f, s);
   close (f);
end.
