{   971115V3.PAS                                                             }
{   1997-11-15 lahtise olmpiaadi vanema rhma 3. lesande lahendus          }
{   Autor: Ahto Truu                                                         }

const
   max = 40;
type
   poly = array [0..max] of integer;

{ loeb antud failist polnoomi }
procedure loe_poly (var f : text; var p : poly);
var i, k, a : integer; c : char;
begin
   for i := 0 to max do p[i] := 0;
   if seekeoln (f) then c := #0 else read (f, c);
   repeat
      if c in ['-', '+'] then begin
         if c = '-' then i := -1;
         if c = '+' then i := +1;
         if seekeoln (f) then c := #0 else read (f, c);
      end else
         i := 1;
      if c in ['0'..'9'] then begin
         k := 0;
         repeat
            k := 10 * k + ord (c) - ord ('0');
            if seekeoln (f) then c := #0 else read (f, c);
         until not (c in ['0'..'9']);
      end else
         k := 1;
      k := k * i;
      if c in ['x', 'X'] then begin
         if seekeoln (f) then c := #0 else read (f, c);
         if c in ['0'..'9'] then begin
            a := 0;
            repeat
               a := 10 * a + ord (c) - ord ('0');
               if seekeoln (f) then c := #0 else read (f, c);
            until not (c in ['0'..'9']);
         end else
            a := 1;
      end else
         a := 0;
      p[a] := p[a] + k;
   until c = #0;
   readln (f);
end;

{ korrutab p1 ja p2, salvestab tulemuse p }
procedure kor_poly (var p, p1, p2 : poly);
var i, j, k : integer;
begin
   for k := 0 to max do
      p[k] := 0;
   for i := 0 to max do
      for j := 0 to max do
         if not (i + j > max) then
            p[i+j] := p[i+j] + p1[i] * p2[j];
end;

{ trkib polnoomi antud faili }
procedure trk_poly (var f : text; p : poly);
var i : integer; n : boolean;
begin
   n := true;
   for i := max downto 0 do
      if p[i] <> 0 then begin
         if (p[i] > 0) and not n then write (f, '+');
         if (p[i] < 0) then write (f, '-');
         if (abs (p[i]) > 1) or (i = 0) then write (f, abs (p[i]));
         if (i > 0) then write (f, 'x');
         if (i > 1) then write (f, i);
         n := false;
      end;
   if n then write (f, '0');
   writeln (f);
end;

var
   f : text;
   p, p1, p2 : poly;
begin
   assign (f, 'input.txt'); reset (f);
   loe_poly (f, p1); loe_poly (f, p2);
   close (f);
   kor_poly (p, p1, p2);
   assign (f, 'output.txt'); rewrite (f);
   trk_poly (f, p);
   close (f);
end.
